package gui;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

import java.util.*;

import qm.QueryManager;

public class UserInterface extends JFrame {
	private QueryManager qm;

	public UserInterface(QueryManager qm)
	{
		this.qm=qm;
		setupWin();
	}
	
	private void exitSW(int exitCode)
	{
		System.out.println();
		System.out.println(">>>>>>>>>>>>><<<<<<<<<<<<<<");
		System.out.println(">> Good bye. Terminating <<");
		System.out.println(">>>>>>>>>>>>><<<<<<<<<<<<<<");

		System.exit(exitCode);
	}

	private void setupWin()
	{
		//closing window by hitting "X"
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e)
			{
				exitSW(0);
			}
		});

		setTitle("Mehrsprachliches Semantic Web");
		setSize(400, 300);

		//layout-manager, set the layout!
		GridBagLayout gb=new GridBagLayout();
		GridBagConstraints c=new GridBagConstraints();
		
		c.anchor=GridBagConstraints.NORTHWEST;
		c.fill=GridBagConstraints.BOTH;
		c.insets=new Insets(0, 0, 0, 0);

		getContentPane().setLayout(gb);
		
		this.setJMenuBar(setupJMenuBar());
		
		JTextField tf=setupJTextField();
		c.gridx=0;
		c.gridy=0;
		gb.setConstraints(tf, c);
		getContentPane().add(tf);
		
		JButton butt=setupJButton();
		c.gridx=1;
		c.gridy=0;
		gb.setConstraints(butt, c);
		getContentPane().add(butt);
		
		JScrollPane out=setupJEditorPane();
		c.gridwidth=2;
		c.gridx=0;
		c.gridy=1;
		gb.setConstraints(out, c);
		getContentPane().add(out);

		show();
	}
	
	
	private JScrollPane setupJEditorPane()
	{
		JEditorPane htmlPane=new JEditorPane();
		htmlPane.setEditable(false);
//		htmlPane.setSize(640, 300);

		return new JScrollPane(htmlPane);
	}
	
	private JButton setupJButton()
	{
		JButton b1=new JButton();
//		b1.setSize(80, 30);
		b1.setText("Suchen");
		b1.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				Vector dummySearch=new Vector();
				JTextField tf=(JTextField)getContentPane().getComponent(0);
				
				//!!!TO-DO!!!
				tf.getText();
				//CUT MY INTO PIECES
				dummySearch.add(tf.getText());
				//!!!TO-DO!!!

				qm.search(dummySearch);
			}
		});

		return b1;
	}
	
	private JTextField setupJTextField()
	{
		JTextField tf=new JTextField("Stolzenburg");
//		tf.setSize(300, 30);
		return tf;
	}

	private JMenuBar setupJMenuBar()
	{
		//File >> exit
		JMenuItem i2=new JMenuItem("Exit Program");
		i2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				exitSW(0);
			}
		});
		
		JMenuItem i1=new JMenuItem("Re-Parse Ontology");
		i1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				qm.parseRdfs();
			}
		});
		
		JMenuItem i3=new JMenuItem("Show ontology details");
		i3.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				qm.showRdfsDetails();
			}
		});
		
		JMenu m1=new JMenu("File");
		m1.add(i2);

		JMenu m2=new JMenu("RDFS");
		m2.add(i1);
		m2.add(i3);
		
		JMenuBar bm=new JMenuBar();
		bm.add(m1);
		bm.add(m2);

		return bm;
	}
}
