package qm;

import java.util.*; 

/**
 * @author felix
 *
 * Template  
 */

public class QueryManager
{
	private RDFSParser rdfs;
	private RDFParser rdf;
	
	/**
	 * The wrapper for the backend rdfs- and rdf-parser.
	 */
	public QueryManager(String pathRdfs, String rdf)
	{
		rdfs=new RDFSParser(pathRdfs);
		//rdf=new RDFParser(pathRdf);
	}

	/**
	 * @param ao (request array)
	 * @return Vector uris
	 * 
	 * Performs the search triggered by gui.UserInterface 
	 */
	public Vector search(Vector ao)
	{
		System.out.println(">> Search request: " + ao.toString());

		//rdfs-search		
		Vector rdfsResponse=rdfs.find(ao);

		//nothing could be found --
		//no rdf-search will be performed to save power
		if (rdfsResponse==null)
			return new Vector();

		//rdf-search
		return rdf.find(rdfsResponse);
	}

	/**
	 * Parses the rdfs file another time
	 * No thread. Stay tuned and calm. 
	 */
	public void parseRdfs()
	{
		rdfs.parseFile();
	}

	public void showRdfsDetails()
	{
		rdfs.showDetails();
	}
}
