package qm;

import java.util.*;
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.ontology.*;
import com.hp.hpl.jena.util.iterator.*;

public class RDFSParser
{
	private String ontologyPath;
	private OntModel m;
	
	public RDFSParser(String ontologyPath)
	{
		this.ontologyPath=ontologyPath;

		m=ModelFactory.createOntologyModel(OntModelSpec.RDFS_MEM, null);
		
		parseFile();
	}

	/**
	 * Parses rdfs-ontology file and prepares the models 
	 */
	public void parseFile()
	{
		System.out.println(">> Parsing RDFS-Ontology");
		
		m.read("file:" + ontologyPath);

		System.out.println(">> Parser-Father: Ontology is on-line!");
	}

	/**
	 * @param ao (request vector)
	 * @return Vector rdf-uris
	 * 
	 * Method triggered by QueryManager::search
	 * @see QueryManager.search
	 */
	public Vector find(Vector ao)
	{
		if (ao.isEmpty())
			return null;

		Vector rdfsResponse=new Vector();
		Iterator i=ao.iterator();
		while (i.hasNext())
		{
			String current=(String)i.next();

			System.out.println(">> Scanning for " + current);

			//Individual -- individual in ontology
			//DocumentManager -- handles multiple rdfs-file-onts in one ontology

			System.out.println(m);

			System.out.println(m.getResource(current));
			
			System.out.println(m.getIndividual(current));

			//blah blah
			//todo

		}
		
		//if no rdfs-uris could be found-return _null_ elsewise vector
		return rdfsResponse.size()==0 ?
				null : rdfsResponse;
	}

	public void showDetails()
	{
		System.out.println(">> Ontology's profile scheme: " + m.getProfile().NAMESPACE());
		
	}
}
